searchNodes=[{"doc":"Exposes all of the Key Value store APIs.","ref":"ram.html","title":"ram","type":"module"},{"doc":"Adds Node to an existing Ram cluster. This method is to be called when: Adding a new node to the cluster. Restarting a previously stopped node of the cluster, so that it joins the cluster again.","ref":"ram.html#add_node/1","title":"ram.add_node/1","type":"function"},{"doc":"Deletes a Key.","ref":"ram.html#delete/1","title":"ram.delete/1","type":"function"},{"doc":"Looks up a Key. Returns error if the Key is not found.","ref":"ram.html#fetch/1","title":"ram.fetch/1","type":"function"},{"doc":"Equivalent to get(Key, undefined) .","ref":"ram.html#get/1","title":"ram.get/1","type":"function"},{"doc":"Returns the Key's Value or Default if the Key is not found. Examples Elixir iex ( 1 ) &gt; : ram . get ( &quot;key&quot; ) : undefined iex ( 2 ) &gt; : ram . get ( &quot;key&quot; , &quot;default&quot; ) &quot;default&quot; iex ( 3 ) &gt; : ram . put ( &quot;key&quot; , &quot;value&quot; ) : ok iex ( 4 ) &gt; : ram . get ( &quot;key&quot; ) &quot;value&quot; Erlang 1 &gt; ram : get ( &quot;key&quot; ) . undefined 2 &gt; ram : get ( &quot;key&quot; , &quot;default&quot; ) . &quot;default&quot; 3 &gt; ram : put ( &quot;key&quot; , &quot;value&quot; ) . ok 4 &gt; ram : get ( &quot;key&quot; ) . &quot;value&quot;","ref":"ram.html#get/2","title":"ram.get/2","type":"function"},{"doc":"Returns the nodes in the Ram cluster.","ref":"ram.html#nodes/0","title":"ram.nodes/0","type":"function"},{"doc":"Puts a Value for a Key.","ref":"ram.html#put/2","title":"ram.put/2","type":"function"},{"doc":"Removes Node from the Ram cluster.","ref":"ram.html#remove_node/1","title":"ram.remove_node/1","type":"function"},{"doc":"Starts Ram manually. In most cases Ram will be started as one of your application's dependencies, however you may use this helper method to start it manually.","ref":"ram.html#start/0","title":"ram.start/0","type":"function"},{"doc":"Starts the Ram cluster.","ref":"ram.html#start_cluster/1","title":"ram.start_cluster/1","type":"function"},{"doc":"Stops Ram manually.","ref":"ram.html#stop/0","title":"ram.stop/0","type":"function"},{"doc":"Stops the Ram cluster.","ref":"ram.html#stop_cluster/1","title":"ram.stop_cluster/1","type":"function"},{"doc":"Atomically updates a Key with the given function. If Key is found then the existing Value is passed to the fun and its result is used as the updated Value of Key. If Key is not found, Default is put as the Value of Key. The Default value will not be passed through the update function. ⚠ Passing functions as arguments might not be compatible across different Erlang versions, so if your cluster is composed of nodes running different Erlang versions do not use this method. Examples Elixir iex ( 1 ) &gt; update_fun = fn existing_value -&gt; existing_value * 2 end # Function &lt; 44.65746770 / 1 in : erl_eval . expr / 5 &gt; iex ( 2 ) &gt; : ram . update ( &quot;key&quot; , 10 , update_fun ) ok iex ( 3 ) &gt; : ram . get ( &quot;key&quot; ) 10 iex ( 4 ) &gt; : ram . update ( &quot;key&quot; , 10 , update_fun ) ok iex ( 5 ) &gt; : ram . get ( &quot;key&quot; ) 20 Erlang 1 &gt; UpdateFun = fun ( ExistingValue ) -&gt; ExistingValue * 2 end . # Fun &lt; erl_eval . 44.65746770 &gt; 2 &gt; ram : update ( &quot;key&quot; , 10 , UpdateFun ) . ok 3 &gt; ram : get ( &quot;key&quot; ) . 10 4 &gt; ram : update ( &quot;key&quot; , 10 , UpdateFun ) . ok 5 &gt; ram : get ( &quot;key&quot; ) . 20","ref":"ram.html#update/3","title":"ram.update/3","type":"function"},{"doc":"Ram Ram is a distributed KV store for Erlang and Elixir. It chooses Consistency over Availability by using the Raft Consensus Algorithm , and is based on Rabbit MQ's implementation Ra . [ Documentation ]","ref":"readme.html","title":"README","type":"extras"},{"doc":"For Elixir Add it to your deps: defp deps do [ { :ram , &quot;~&gt; 0.4&quot; } ] end For Erlang If you're using rebar3 , add ram as a dependency in your project's rebar.config file: { deps , [ { ram , { git , &quot;git://github.com/ostinelli/ram.git&quot; , { tag , &quot;0.4.0&quot; } } } ] } . Or, if you're using Hex.pm as package manager (with the rebar3_hex plugin): { deps , [ { ram , &quot;0.4.0&quot; } ] } .","ref":"readme.html#installation","title":"README - Installation","type":"extras"},{"doc":"Note: this example below assumes that you are familiar with Distributed Erlang . Elixir Open 3 shells and start three Erlang nodes: $ iex --name ram1@127.0.0.1 -S mix $ iex --name ram2@127.0.0.1 -S mix $ iex --name ram3@127.0.0.1 -S mix Choose the main node (for instance ram1@127.0.0.1 ), and on that node run the following. First, create an Erlang cluster by connecting all nodes: iex ( ram1 @ 127.0 . 0.1 ) 1 &gt; nodes = [ : &quot;ram1@127.0.0.1&quot; , : &quot;ram2@127.0.0.1&quot; , : &quot;ram3@127.0.0.1&quot; ] [ : &quot;ram1@127.0.0.1&quot; , : &quot;ram2@127.0.0.1&quot; , : &quot;ram3@127.0.0.1&quot; ] iex ( ram1 @ 127.0 . 0.1 ) 2 &gt; for node &lt;- nodes , do : Node . connect ( node ) [ true , true , true ] Now we can create a Ram cluster running on these nodes: iex ( ram1 @ 127.0 . 0.1 ) 3 &gt; : ram . start_cluster ( nodes ) 13 : 03 : 12.902 [ info ] RAM [ ram1 @ 127.0 . 0.1 ] Cluster started on [ : &quot;ram1@127.0.0.1&quot; , : &quot;ram2@127.0.0.1&quot; , : &quot;ram3@127.0.0.1&quot; ] : ok You can now store and retrieve values from all the nodes: iex ( ram1 @ 127.0 . 0.1 ) 4 &gt; : ram . put ( &quot;key&quot; , &quot;value&quot; ) : ok iex ( ram1 @ 127.0 . 0.1 ) 5 &gt; : ram . get ( &quot;key&quot; ) &quot;value&quot; iex ( ram2 @ 127.0 . 0.1 ) 5 &gt; : ram . get ( &quot;key&quot; ) &quot;value&quot; iex ( ram3 @ 127.0 . 0.1 ) 5 &gt; : ram . get ( &quot;key&quot; ) &quot;value&quot; Erlang Open 3 shells and start three Erlang nodes: $ rebar3 shell --name ram1@127.0.0.1 $ rebar3 shell --name ram2@127.0.0.1 $ rebar3 shell --name ram3@127.0.0.1 Choose the main node (for instance ram1@127.0.0.1 ), and on that node run the following. First, create an Erlang cluster by connecting all nodes: ( ram1 @ 127.0 . 0.1 ) 1 &gt; Nodes = [ &#39;ram1@127.0.0.1&#39; , &#39;ram2@127.0.0.1&#39; , &#39;ram3@127.0.0.1&#39; ] . [ &#39;ram1@127.0.0.1&#39; , &#39;ram2@127.0.0.1&#39; , &#39;ram3@127.0.0.1&#39; ] ( ram1 @ 127.0 . 0.1 ) 2 &gt; [ net_kernel : connect_node ( Node ) || Node &lt;- Nodes ] . [ true , true , true ] Now we can create a Ram cluster running on these nodes: ( ram1 @ 127.0 . 0.1 ) 3 &gt; ram : start_cluster ( Nodes ) . = INFO REPORT == == 4 - Jan - 2022 : : 12 : 46 : 34.071524 == = RAM [ ram1 @ 127.0 . 0.1 ] Cluster started on [ &#39;ram1@127.0.0.1&#39; , &#39;ram2@127.0.0.1&#39; , &#39;ram3@127.0.0.1&#39; ] ok You can now store and retrieve values from all the nodes: ( ram1 @ 127.0 . 0.1 ) 4 &gt; ram : put ( &quot;key&quot; , &quot;value&quot; ) . ok ( ram1 @ 127.0 . 0.1 ) 5 &gt; ram : get ( &quot;key&quot; ) . &quot;value&quot; ( ram2 @ 127.0 . 0.1 ) 1 &gt; ram : get ( &quot;key&quot; ) . &quot;value&quot; ( ram3 @ 127.0 . 0.1 ) 1 &gt; ram : get ( &quot;key&quot; ) . &quot;value&quot;","ref":"readme.html#quick-start","title":"README - Quick start","type":"extras"},{"doc":"release_cursor_count Specifies after how many logs ram should create a ra snapshot. Defaults to 1000 . Elixir config :ram , release_cursor_count : 1000 Erlang { ram , [ { release_cursor_count , 1000 } ] } Other settings Since Ram uses Ra , please refer to Ra's documentation on available options.","ref":"readme.html#configuration-options","title":"README - Configuration Options","type":"extras"},{"doc":"So you want to contribute? That's great! Please follow the guidelines below. It will make it easier to get merged in. Before implementing a new feature, please submit a ticket to discuss what you intend to do. Your feature might already be in the works, or an alternative implementation might have already been discussed. Do not commit to master in your fork. Provide a clean branch without merge commits. Every pull request should have its own topic branch. In this way, every additional adjustments to the original pull request might be done easily, and squashed with git rebase -i . The updated branch will be visible in the same pull request, so there will be no need to open new pull requests when there are changes to be applied. Ensure that proper testing is included. To run Ram tests you simply have to be in the project's root directory and run: $ make test","ref":"readme.html#contributing","title":"README - Contributing","type":"extras"},{"doc":"Copyright (c) 2021-2022 Roberto Ostinelli. Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"readme.html#license","title":"README - License","type":"extras"}]